import java.sql.*;
import java.io.*;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioFileFormat;
import javax.sound.sampled.AudioSystem;

public class blobTest
{
	public static void main(String[] args)
    {
		try
		{
			String url = "jdbc:derby:blobberyblob;create=true";

			Class.forName("org.apache.derby.jdbc.EmbeddedDriver").newInstance();
			Connection conn = DriverManager.getConnection(url);

            Statement s = conn.createStatement();
            s.executeUpdate("CREATE TABLE documents (id INT, pic blob(16M))");
            conn.commit();

            java.io.File file = new java.io.File("captureFile.wav");
            int fileLength = (int) file.length();

            System.out.println("Creating an input stream");
            java.io.InputStream fin = new java.io.FileInputStream(file);
            PreparedStatement ps = conn.prepareStatement(
                                "INSERT INTO documents VALUES (?, ?)");
            ps.setInt(1, 1477);

            System.out.println("Set the value of the input parameter");

            ps.setBinaryStream(2, fin, fileLength);
            ps.execute();
            conn.commit();

            ResultSet rs = s.executeQuery(
                                "SELECT pic FROM documents WHERE id = 1477");

            while (rs.next())
            {
                java.sql.Blob ablob = rs.getBlob(1);
                java.io.InputStream ip = rs.getBinaryStream(1);

                FileOutputStream op = new FileOutputStream("dbsound.wav");

                op.write(ablob.getBytes(1, (int)ablob.length()));

                System.out.println("BLOB length = " + ablob.length());

                op.close();
				ip.close();

                System.out.print("\n");
            }
        }
        catch (Exception e)
        {
            System.out.println("Error! "+e);
        }
    }
}